<?php
/* Autor...: William L. Taype Perez */
/* Esquema.: MKT_PromocionCab.xml */
/* Generado: 2022-02-09 07:47:18 */

/* Mantenimiento de los registros de la tabla MKT_PromocionCab */
abstract class BaseMKT_PromocionCabDP extends MKT_PromocionCabBV
{
    /* Constructor ( Establece los valores desde un objeto MKT_PromocionCabBN ) */
    public function __construct( MKT_PromocionCabBN $o_MKT_PromocionCabBN = null )
    {
        parent::__construct();
        if ( !is_null( $o_MKT_PromocionCabBN ) )
        {
            $this->setByBN( $o_MKT_PromocionCabBN );
        }
    }

    public $b_Debug = false;

    public function getDebug()
    {
        if( SF_DEBUG )
        {
            $this->b_Debug = true;
        }
        return $this->b_Debug;
    }

    public function setDebug( $v )
    {
        $this->b_Debug = $v;
    }

    /* Establece los valores desde un objeto MKT_PromocionCabBN */
    public function setByBN( MKT_PromocionCabBN $o_MKT_PromocionCabBN )
    {
        if ( !is_null( $o_MKT_PromocionCabBN->getIdPromoCab() ) )
        {
            $this->setIdPromoCab( $o_MKT_PromocionCabBN->getIdPromoCab() );
        }
        if ( !is_null( $o_MKT_PromocionCabBN->getIdCompania() ) )
        {
            $this->setIdCompania( $o_MKT_PromocionCabBN->getIdCompania() );
        }
        if ( !is_null( $o_MKT_PromocionCabBN->getIdSucursal() ) )
        {
            $this->setIdSucursal( $o_MKT_PromocionCabBN->getIdSucursal() );
        }
        if ( !is_null( $o_MKT_PromocionCabBN->getIdAlmacen() ) )
        {
            $this->setIdAlmacen( $o_MKT_PromocionCabBN->getIdAlmacen() );
        }
        if ( !is_null( $o_MKT_PromocionCabBN->getIdItemTipo() ) )
        {
            $this->setIdItemTipo( $o_MKT_PromocionCabBN->getIdItemTipo() );
        }
        if ( !is_null( $o_MKT_PromocionCabBN->getCodigoPromo() ) )
        {
            $this->setCodigoPromo( $o_MKT_PromocionCabBN->getCodigoPromo() );
        }
        if ( !is_null( $o_MKT_PromocionCabBN->getDescripcionPromo() ) )
        {
            $this->setDescripcionPromo( $o_MKT_PromocionCabBN->getDescripcionPromo() );
        }
        if ( !is_null( $o_MKT_PromocionCabBN->getFechaInicio() ) )
        {
            $this->setFechaInicio( $o_MKT_PromocionCabBN->getFechaInicio() );
        }
        if ( !is_null( $o_MKT_PromocionCabBN->getFechaFin() ) )
        {
            $this->setFechaFin( $o_MKT_PromocionCabBN->getFechaFin() );
        }
        if ( !is_null( $o_MKT_PromocionCabBN->getEstadoPromo() ) )
        {
            $this->setEstadoPromo( $o_MKT_PromocionCabBN->getEstadoPromo() );
        }
        if ( !is_null( $o_MKT_PromocionCabBN->getCantidadPromo() ) )
        {
            $this->setCantidadPromo( $o_MKT_PromocionCabBN->getCantidadPromo() );
        }
        if ( !is_null( $o_MKT_PromocionCabBN->getCantidadFacturado() ) )
        {
            $this->setCantidadFacturado( $o_MKT_PromocionCabBN->getCantidadFacturado() );
        }
        if ( !is_null( $o_MKT_PromocionCabBN->getCostoConIGVPromo() ) )
        {
            $this->setCostoConIGVPromo( $o_MKT_PromocionCabBN->getCostoConIGVPromo() );
        }
        if ( !is_null( $o_MKT_PromocionCabBN->getPrecioSinIGVPromo() ) )
        {
            $this->setPrecioSinIGVPromo( $o_MKT_PromocionCabBN->getPrecioSinIGVPromo() );
        }
        if ( !is_null( $o_MKT_PromocionCabBN->getMontoIGVPromo() ) )
        {
            $this->setMontoIGVPromo( $o_MKT_PromocionCabBN->getMontoIGVPromo() );
        }
        if ( !is_null( $o_MKT_PromocionCabBN->getPrecioConIGVPromo() ) )
        {
            $this->setPrecioConIGVPromo( $o_MKT_PromocionCabBN->getPrecioConIGVPromo() );
        }
        if ( !is_null( $o_MKT_PromocionCabBN->getDescuentoTotalPromo() ) )
        {
            $this->setDescuentoTotalPromo( $o_MKT_PromocionCabBN->getDescuentoTotalPromo() );
        }
        if ( !is_null( $o_MKT_PromocionCabBN->getComentarioPromo() ) )
        {
            $this->setComentarioPromo( $o_MKT_PromocionCabBN->getComentarioPromo() );
        }
        if ( !is_null( $o_MKT_PromocionCabBN->getFechaCreacion() ) )
        {
            $this->setFechaCreacion( $o_MKT_PromocionCabBN->getFechaCreacion() );
        }
        if ( !is_null( $o_MKT_PromocionCabBN->getUsuarioCreacion() ) )
        {
            $this->setUsuarioCreacion( $o_MKT_PromocionCabBN->getUsuarioCreacion() );
        }
        if ( !is_null( $o_MKT_PromocionCabBN->getFechaModificacion() ) )
        {
            $this->setFechaModificacion( $o_MKT_PromocionCabBN->getFechaModificacion() );
        }
        if ( !is_null( $o_MKT_PromocionCabBN->getUsuarioModificacion() ) )
        {
            $this->setUsuarioModificacion( $o_MKT_PromocionCabBN->getUsuarioModificacion() );
        }
    }

    /* Graba un nuevo registro */
    public function save()
    {
        $this->validateRecord();
        $o_MKT_PromocionCabFN = new MKT_PromocionCabFN();
        $o_MKT_PromocionCabBN = $o_MKT_PromocionCabFN->selectByPk( $this->getIdPromoCab() );
        if ( is_null( $o_MKT_PromocionCabBN ) )
        {
            $s_SQLQuery1 = "INSERT INTO MKT_PromocionCab ( ";
            $s_SQLQuery2 = "VALUES ( ";
            $s_Separator = "";
            if ( !is_null( $this->getIdPromoCab() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdPromoCab";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdPromoCab()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdCompania() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdCompania";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdCompania()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdSucursal() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdSucursal";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdSucursal()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdAlmacen() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdAlmacen";
                $s_SQLQuery2 .= $s_Separator."'".$this->getIdAlmacen()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdItemTipo() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdItemTipo";
                $s_SQLQuery2 .= $s_Separator."'".$this->getIdItemTipo()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getCodigoPromo() ) )
            {
                $s_SQLQuery1 .= $s_Separator."CodigoPromo";
                $s_SQLQuery2 .= $s_Separator."'".$this->getCodigoPromo()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getDescripcionPromo() ) )
            {
                $s_SQLQuery1 .= $s_Separator."DescripcionPromo";
                $s_SQLQuery2 .= $s_Separator."'".$this->getDescripcionPromo()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaInicio() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaInicio";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaInicio()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaFin() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaFin";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaFin()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getEstadoPromo() ) )
            {
                $s_SQLQuery1 .= $s_Separator."EstadoPromo";
                $s_SQLQuery2 .= $s_Separator."'".$this->getEstadoPromo()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getCantidadPromo() ) )
            {
                $s_SQLQuery1 .= $s_Separator."CantidadPromo";
                $s_SQLQuery2 .= $s_Separator."".$this->getCantidadPromo()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getCantidadFacturado() ) )
            {
                $s_SQLQuery1 .= $s_Separator."CantidadFacturado";
                $s_SQLQuery2 .= $s_Separator."".$this->getCantidadFacturado()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getCostoConIGVPromo() ) )
            {
                $s_SQLQuery1 .= $s_Separator."CostoConIGVPromo";
                $s_SQLQuery2 .= $s_Separator."".$this->getCostoConIGVPromo()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getPrecioSinIGVPromo() ) )
            {
                $s_SQLQuery1 .= $s_Separator."PrecioSinIGVPromo";
                $s_SQLQuery2 .= $s_Separator."".$this->getPrecioSinIGVPromo()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getMontoIGVPromo() ) )
            {
                $s_SQLQuery1 .= $s_Separator."MontoIGVPromo";
                $s_SQLQuery2 .= $s_Separator."".$this->getMontoIGVPromo()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getPrecioConIGVPromo() ) )
            {
                $s_SQLQuery1 .= $s_Separator."PrecioConIGVPromo";
                $s_SQLQuery2 .= $s_Separator."".$this->getPrecioConIGVPromo()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getDescuentoTotalPromo() ) )
            {
                $s_SQLQuery1 .= $s_Separator."DescuentoTotalPromo";
                $s_SQLQuery2 .= $s_Separator."".$this->getDescuentoTotalPromo()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getComentarioPromo() ) )
            {
                $s_SQLQuery1 .= $s_Separator."ComentarioPromo";
                $s_SQLQuery2 .= $s_Separator."'".$this->getComentarioPromo()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaCreacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaCreacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioCreacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."UsuarioCreacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getUsuarioCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaModificacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaModificacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaModificacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioModificacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."UsuarioModificacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getUsuarioModificacion()."'";
                $s_Separator = ", ";
            }
            $s_SQLQuery = $s_SQLQuery1." ) ".$s_SQLQuery2." );";
            if( $this->getDebug() ){ pr( $s_SQLQuery ); }
            $o_Resource = Conexion::getConexion();
            $o_Statement = $o_Resource->createStatement();
            $o_Statement->executeQuery( $s_SQLQuery );
        }
        else
        {
            throw new Exception( "El id ya esta registrado." );
        }
        return true;
    }

    /* Actualiza los datos del registro */
    public function update()
    {
        $this->validateRecord();
        if ( true )
        {
            $s_SQLQuery = "UPDATE MKT_PromocionCab SET ";
            $s_Separator = "";
            if ( !is_null( $this->getIdCompania() ) )
            {
                $s_SQLQuery .= $s_Separator."IdCompania = ".$this->getIdCompania()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdSucursal() ) )
            {
                $s_SQLQuery .= $s_Separator."IdSucursal = ".$this->getIdSucursal()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdAlmacen() ) )
            {
                $s_SQLQuery .= $s_Separator."IdAlmacen = '".$this->getIdAlmacen()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdItemTipo() ) )
            {
                $s_SQLQuery .= $s_Separator."IdItemTipo = '".$this->getIdItemTipo()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getCodigoPromo() ) )
            {
                $s_SQLQuery .= $s_Separator."CodigoPromo = '".$this->getCodigoPromo()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getDescripcionPromo() ) )
            {
                $s_SQLQuery .= $s_Separator."DescripcionPromo = '".$this->getDescripcionPromo()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaInicio() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaInicio = '".$this->getFechaInicio()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaFin() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaFin = '".$this->getFechaFin()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getEstadoPromo() ) )
            {
                $s_SQLQuery .= $s_Separator."EstadoPromo = '".$this->getEstadoPromo()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getCantidadPromo() ) )
            {
                $s_SQLQuery .= $s_Separator."CantidadPromo = ".$this->getCantidadPromo()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getCantidadFacturado() ) )
            {
                $s_SQLQuery .= $s_Separator."CantidadFacturado = ".$this->getCantidadFacturado()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getCostoConIGVPromo() ) )
            {
                $s_SQLQuery .= $s_Separator."CostoConIGVPromo = ".$this->getCostoConIGVPromo()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getPrecioSinIGVPromo() ) )
            {
                $s_SQLQuery .= $s_Separator."PrecioSinIGVPromo = ".$this->getPrecioSinIGVPromo()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getMontoIGVPromo() ) )
            {
                $s_SQLQuery .= $s_Separator."MontoIGVPromo = ".$this->getMontoIGVPromo()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getPrecioConIGVPromo() ) )
            {
                $s_SQLQuery .= $s_Separator."PrecioConIGVPromo = ".$this->getPrecioConIGVPromo()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getDescuentoTotalPromo() ) )
            {
                $s_SQLQuery .= $s_Separator."DescuentoTotalPromo = ".$this->getDescuentoTotalPromo()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getComentarioPromo() ) )
            {
                $s_SQLQuery .= $s_Separator."ComentarioPromo = '".$this->getComentarioPromo()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaCreacion() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaCreacion = '".$this->getFechaCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioCreacion() ) )
            {
                $s_SQLQuery .= $s_Separator."UsuarioCreacion = '".$this->getUsuarioCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaModificacion() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaModificacion = '".$this->getFechaModificacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioModificacion() ) )
            {
                $s_SQLQuery .= $s_Separator."UsuarioModificacion = '".$this->getUsuarioModificacion()."'";
                $s_Separator = ", ";
            }
            $s_SQLQuery .= " WHERE  IdPromoCab = ".$this->getIdPromoCab().";";
            if( $this->getDebug() ){ pr( $s_SQLQuery ); }

            $o_Resource = Conexion::getConexion();
            $o_Statement = $o_Resource->createStatement();
            $o_Statement->executeQuery( $s_SQLQuery );
        }
        else
        {
            throw new Exception( "El id no esta registrado." );
        }
        return true;
    }

    /* Elimina el registro */
    public function delete()
    {
        $s_SQLQuery = "DELETE FROM MKT_PromocionCab WHERE  IdPromoCab = ".$this->getIdPromoCab().";";
        if( $this->getDebug() ){ pr( $s_SQLQuery ); }
        $o_Resource = Conexion::getConexion();
        $o_Statement = $o_Resource->createStatement();
        $o_Statement->executeQuery( $s_SQLQuery );
        return true;
    }

}
?>